﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace AuKCSharp
{
    class Program
    {

        static void Main(string[] args)
        {
            new Program(args);
        }
        public Program(string[] args)
        {
            if (args.Length != 2)
            {
                Console.WriteLine("Funktionen:");
                Console.WriteLine(" Fib \n FibM \n RucksackI \n RucksackR \n RucksackRM");
                Console.WriteLine("und dann noch ein N als Integer-Paramenter angeben");
                Console.WriteLine("--------------------------------------------------");
            }
            if (args.Length == 2)
            {
                Fib f = new Fib();
                Rucksack r = new Rucksack();
                switch (args[0])
                {
                    case "Fib":
                        Console.WriteLine("Fib von " + args[1] + " = " + f.fib(Convert.ToInt32(args[1])));
                        System.Console.WriteLine("rekursive Aufrufe: " + f.counter);
                        break;
                    case "FibM":
                        Console.WriteLine("Fib mit Map/Set/Hash von " + args[1] + " = " + f.fibM(Convert.ToUInt64(args[1])));
                        System.Console.WriteLine("rekursive Aufrufe: " + f.counter);
                        break;
                    case "RucksackI":
                        r.printIterativ(Convert.ToInt32(args[1]));
                        break;
                    case "RucksackR":
                        Console.WriteLine("Rucksack rekursiv " + args[1] + " = " + r.gesamtwertRekursiv(Convert.ToInt32(args[1])));
                        break;
                    case "RucksackRM":
                        Console.WriteLine("Rucksack rekursiv mit Memo " + args[1] + " = " + r.gesamtwertRekursivMemo(Convert.ToInt32(args[1])));
                        break;
                    default:
                        break;
                }                
            }           
        }
    }
}